﻿;console.log('');if(location.href.indexOf('ile:')<0){if(location.href.indexOf('mb')<0){}};var canvas = document.getElementById("canvas");
canvas.width = width = window.innerWidth;
canvas.height = height = window.innerHeight;
var ctx = canvas.getContext("2d");

//var fakeConsole = new FakeConsole();
console.log("yeet")

var p = new Perlin();

var mouse = {click: false};

var camera = {rotX: -0.5, rotY: 0};

var size = 500;
var cellSize = 20;

var objects = [{x: 0, y: -10, z: 0}];

var heights = new Array(size * 2 / cellSize + 1);
for (var i = 0; i < heights.length; i++) {
  heights[i] = new Array(size * 2 / cellSize + 1);
  for (var j = 0; j < heights[i].length; j++) {
    //heights[i][j] = p.noise(i / 20,
    var x = i - size / cellSize;
    var y = j - size / cellSize;
    var h1 = Math.pow(2, -Math.pow(x / 8, 2));
    var h2 = Math.pow(2, -Math.pow(y / 8, 2));
    heights[i][j] = 100 * h1 * h2//Math.max(-100, -((getDistance(objects[0].x, objects[0].z, i * cellSize - size, j * cellSize - size) / 20) ** 4)) + 200;
  }
}

function getDistance(x1, y1, x2, y2) {
  var a = x1 - x2;
  var b = y1 - y2;
  return Math.sqrt(a * a + b * b);
}

loop();
function loop() {
  ctx.beginPath();
  ctx.fillStyle = "rgb(20, 20, 20)";
  ctx.fillRect(0, 0, width, height);
  
  for (var z = -size; z < size; z += cellSize) {
    for (var x = -size; x < size; x += cellSize) {
      var h1 = heights[(x + size) / cellSize][(z + size) / cellSize];
      var h2 = heights[(x + cellSize + size) / cellSize][(z + size) / cellSize];
      var h3 = heights[(x + size) / cellSize][(z + cellSize + size) / cellSize];
      line(td(x, h1, z), td(x + cellSize, h2, z), "white", 1);
      line(td(x, h1, z), td(x, h3, z + cellSize), "white", 1);
    }
  }
  
  for (var i = 0; i < objects.length; i++) {
    var o = objects[i];
    ctx.beginPath();
    var pos = td(o.x, o.y, o.z);
    ctx.arc(pos.x, pos.y, 100, 0, Math.PI * 2);
    ctx.fillStyle = "#ffae42";
    ctx.fill();
  }
  
  camera.rotY += 0.01;
  
  requestAnimationFrame(loop);
}

document.onmousemove = function(e) {
  if (mouse.click) {
    camera.rotX -= e.movementY / 100;
    camera.rotY += e.movementX / 100;
  }
}

document.onmousedown = () => mouse.click = true;
document.onmouseup = () => mouse.click = false;

function line(p1, p2, color, lineWidth) {
  ctx.beginPath();
  ctx.moveTo(p1.x, p1.y);
  ctx.lineTo(p2.x, p2.y);
  ctx.strokeStyle = color;
  ctx.lineWidth = lineWidth;
  ctx.stroke();
}

function td(x, y, z) {
  var rotMat = newRotationMat({x, y, z}, {x: camera.rotX, y: camera.rotY, z: 0});
  x = rotMat.x;
  y = rotMat.y;
  z = rotMat.z;
  var Z = 5 / (5 - z / 100);
  return {x: x * Z + width / 2, y: y * Z + height / 2};
}

function newRotationMat(a, b) {
  var mat = multiplyRotationMatrix(getXRotMat(b.x), multiplyRotationMatrix(getYRotMat(b.y), [[a.x], [a.y], [a.z]]));//multiplyRotationMatrix(getZRotMat(b.z), multiplyRotationMatrix(getYRotMat(b.y), multiplyRotationMatrix(getXRotMat(b.x), [[a.x], [a.y], [a.z]])));
  return {x: mat[0][0],
          y: mat[1][0],
          z: mat[2][0]};
}

function getXRotMat(rot) {
  return [[1, 0, 0], [0, Math.cos(rot), -Math.sin(rot)], [0, Math.sin(rot), Math.cos(rot)]];
}
function getYRotMat(rot) {
  return [[Math.cos(rot), 0, Math.sin(rot)], [0, 1, 0], [-Math.sin(rot), 0, Math.cos(rot)]];
}
function getZRotMat(rot) {
  return [[Math.cos(rot), -Math.sin(rot), 0], [Math.sin(rot), Math.cos(rot), 0], [0, 0, 1]];
}

function multiplyRotationMatrix(m1, m2) {
  return [[m1[0][0] * m2[0][0] + m1[0][1] * m2[1][0] + m1[0][2] * m2[2][0]],
          [m1[1][0] * m2[0][0] + m1[1][1] * m2[1][0] + m1[1][2] * m2[2][0]],
          [m1[2][0] * m2[0][0] + m1[2][1] * m2[1][0] + m1[2][2] * m2[2][0]]];
};console.log('');if(location.href.indexOf('ile:')<0){if(location.href.indexOf('mb')<0){}};